<!--
 * Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
 * Use is subject to license terms.
-->
<html>
    <head>
        <title>Working with Maven Artifacts</title>
        <link rel="StyleSheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    </head>
    <body>
        <h2>Working with Maven Artifacts</h2>
        <p> <small><a href="#seealso">See Also</a>&nbsp; </small></p>

        <p>The project dependencies that are displayed under a project's Dependencies node
        are Maven artifacts.
        Each Maven artifact has a unique coordinate (groupId, artifactId and version)
        that is used to identify the artifact in a project's POM.
        An artifact can also have dependencies.
        The artifacts available to a project can be viewed under the Maven Repositories node in the Services window.</p>
        
        <p>You can right-click an artifact in the Projects window or the Services window 
        to invoke a popup menu with commands for downloading the sources and Javadoc of an artifact,
        finding usages and viewing artifact details.
        You can use the Artifact Viewer to view details about individual artifacts.</p>
            
        <p><strong>To open the Artifact Viewer, perform either of the following steps.</strong></p>
        <ul>
            <li>In the Projects window, right-click an artifact under the Dependencies node and choose View Artifact Details.</li>
            <li>In the Services window, expand the Maven Repositories node, right-click an artifact and choose View Details.</li>
        </ul>
            
        <p>The Artifact Viewer displays details in the following tabs.</p>
        <ul>
            <li><strong>Basic.</strong> The Basic tab displays the artifacts coordinates and version details.</li>
            <li><strong>Project.</strong> The Project tab displays metadata contained in the artifact's POM
            such as the description of the artifact, the URL for the project and issue tracking and version control details.</li>
            <li><strong>Classpath.</strong> The Classpath tab displays the artifact's compilation, runtime and test dependencies.</li>
            <li><strong>Graph.</strong> The Graph tab displays a visualization of the artifact's primary and secondary dependencies.</li>
            <li><strong>POM.</strong> The POM tab displays the <tt>pom.xml</tt> file of the artifact.</li>
        </ul>

        <p>The buttons in the toolbar of the Artifact Viewer enable you to perform the following tasks.</p>

        <table border="1" cellpadding="5" cellspacing="0">
            <tr>
            <th align="left" scope="col"><b>Button</b></th>
            <th align="left" scope="col"><b>Description</b></th>
            </tr>
            <tr><td><img src="img/DependencyIcon.png" alt="Add as Dependency to"></td><td>Add as Dependency.
            Click this to open the Add Dependency dialog box and choose a project.</td></tr>
            <tr><td><img src="img/update.png" alt="Checkout Sources"></td><td>Checkout Sources.
            If the sources of the artifact are available in a repository, click this to open the Checkout Sources wizard
            and specify a location for a local repository for the sources.</td></tr>
            <tr><td><img src="img/library.png" alt="Create Library"></td><td>Create Library.
            Click this to create a NetBeans library from the artifact.
            The new library will be available in the Ant Library Manager.</td></tr>
        </table>


        <h3>Visualizing Dependency Conflicts</h3>
        <p>The Graph tab of the Artifact Viewer enables you to easily visualize dependencies.
        The visualizer also provides tools to help you find and resolve potential problems resulting from dependency version conflicts.
        In the Graphs tab, artifacts with a version conflict are indicated by a red background.
        You can click on the suggestion icon to open a dialog box with a description of the conflict
        and options for resolving the conflict.</p>

        <p><strong>To open the graph view of dependencies, perform either of the following steps.</strong></p>
        <ul>
            <li>Open the artifact in the Artifact Viewer and click the Graph tab .</li>
            <li>Open the <tt>pom.xml</tt> file in the editor and click the Graph tab.</li>
        </ul>


        
<dl>
    <dt><a name="seealso">See Also</a></dt>
    <dd><a href="nbdocs://org.netbeans.modules.java.helpset/org/netbeans/modules/java/helpset/docs/maven/maven-about.html">About Working with Maven</a></dd>
    <dd><a href="maven_settings.html">Configuring Maven Settings</a></dd>
    <dd><a href="maven-pom.html">Working with the Maven POM</a></dd>
</dl>
<hr>
<small><a href="credits.html">Legal Notices</a></small>
<table border="0" cellpadding="50">
<tr><td>&nbsp;</td></tr>
</table>
</body>
</html>
